{% macro save(cancelPath, param = {} ,saveName = 'Enregistrer', icon = 'fa fa-save', cancelTitle='Annuler', saveTitle='Ajouter') %}
    <a href="{{ path( cancelPath, param ) }}" class="btn btn-link" title="{{ cancelTitle }}">
        <span class="fa fa-times"></span>
        Annuler
    </a>

    <button class="btn btn-primary" type="submit" title="{{ saveName }}">
        <span class="{{ icon }}"></span>
        {{ saveName }}
    </button>
{% endmacro %}

{% macro emptyList(elements, text) %}
    {% if elements |length == 0 %}
        <tr class="d-flex">
            <td class="col-12 text-center">
                {{ text }}
            </td>
        </tr>
    {% endif %}
{% endmacro %}

{% macro editButton(editPath, id = null, title = 'Modifier') %}
    {% if id ==null %}
        <a href="{{ path(editPath) }}" class="btn btn-outline-primary borderless" title="{{ title }}">
            <span class="fas fa-pen"></span>
        </a>
    {% else %}
        <a href="{{ path(editPath, {'id': id}) }}" class="btn btn-outline-primary borderless" title="{{ title }}">
            <span class="fas fa-pen"></span>
        </a>
    {% endif %}
{% endmacro %}

{% macro backButton(backPath, params = {}) %}
    <a href="{{ path(backPath, params) }}" class="btn btn-outline-primary" title="Retour">
        <span class="fa fa-arrow-left"></span>
        Retour
    </a>
{% endmacro %}

{% macro searchForm(formSearch, searchTerm, resetPath) %}
    {{ form_start(formSearch, {'method': 'GET'}) }}

    <div class="input-group col-8 float-right pr-0">
        {{ form_widget(formSearch.search, {'value': searchTerm}) }}
        <div class="input-group-append">
            <a href="{{ path(resetPath) }}" class="btn btn-warning" title="Effacer">
                <span class="fas fa-times"></span>
            </a>
            <button class="btn btn-primary" title="Filtrer">
                <span class="fas fa-search"></span>
            </button>
        </div>
    </div>
    {{ form_end(formSearch) }}
{% endmacro %}

{% macro showButton(showPath, id, title="Visualiser") %}
    <a href="{{ path(showPath, {'id': id}) }}" class="btn btn-outline-primary borderless" title="{{ title }}">
        <span class="fa fa-eye"></span>
    </a>
{% endmacro %}

{% macro addButton(addPath, label="Ajouter", title="Ajouter", class="btn-primary") %}
    <a href="{{ path(addPath) }}" class="btn {{ class }}" title="{{ title }}">
        <span class="fa fa-plus-circle"></span>
        {{ label }}
    </a>
{% endmacro %}

{% macro batchDeleteButton(addPath, label="Supprimer", title="Supprimer", class="btn-primary") %}
    <a href="{{ path(addPath) }}" class="btn {{ class }}" title="{{ title }}">
        <span class="fa fa-trash-alt"></span>
        {{ label }}
    </a>
{% endmacro %}

{% macro button_open_modal_delete(id, title, pathAction, content, page = 1, titleAttribut = 'Supprimer') %}
    <button type="button" class="btn btn-outline-danger borderless" title="{{ titleAttribut }}"
            data-bs-target="#delete{{ id }}" data-bs-toggle="modal">
        <span class="fa fa-trash-alt"></span>
    </button>

    <div id="delete{{ id }}" class="modal fade" role="dialog">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header d-flex align-items-start">
                    <h4 class="modal-title">
                        {{ title }}
                    </h4>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    {{ content | nl2br | raw }}
                </div>
                <div class="modal-footer">
                    {{ _self.cancelBtnModal() }}

                    <form method="post" action="{{ path(pathAction, {id: id, page: page}) }}" style="display: inline-block">
                        <input type="hidden" name="_method" value="DELETE">
                        <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ id) }}">
                        <button type="submit" class="btn btn-danger">
                            <span class="fa fa-trash-alt"></span>
                            Supprimer
                        </button>
                    </form>
                </div>
            </div>
        </div>
    </div>
{%- endmacro -%}

{% macro button_open_modal_post(id, title, content, pathAction, icon = "fa fa-paper-plane", btn_title = "Envoyer",
    confirmMessage = '<span class="fas fa-exclamation-circle"></span> Confirmer' ) %}
    <button type="button" class="btn btn-outline-warning borderless" title="{{ btn_title }}"
            data-bs-target="#post{{ id }}" data-bs-toggle="modal">
        <span class="{{ icon }}"></span>
    </button>

    <div id="post{{ id }}" class="modal fade" role="dialog" data-bs-backdrop="static">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header d-flex align-items-start">
                    <h4 class="modal-title">
                        {{ title }}
                    </h4>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>                </div>
                <div class="modal-body">
                    {{ content }}
                </div>
                <div class="modal-footer">
                    {{ _self.cancelBtnModal() }}

                    <form method="post" action="{{ path(pathAction, {id: id}) }}" style="display: inline-block">
                        <input type="hidden" name="_token" value="{{ csrf_token('postForm' ~ id) }}">
                        <button type="submit" class="btn btn-danger submit_post">
                            {{ confirmMessage | raw }}
                        </button>
                    </form>
                </div>
            </div>
        </div>
    </div>
{%- endmacro -%}

{% macro button_open_modal_post(id, title, content, pathAction, icon = "fa fa-paper-plane", btn_title = "Envoyer",
    confirmMessage = '<span class="fas fa-exclamation-circle"></span> Confirmer' ) %}
    <button type="button" class="btn btn-outline-warning borderless" title="{{ btn_title }}"
            data-bs-target="#post{{ id }}" data-bs-toggle="modal">
        <span class="{{ icon }}"></span>
    </button>

    <div id="post{{ id }}" class="modal fade" role="dialog" data-bs-backdrop="static">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header align-items-start">
                    <h4 class="modal-title">
                        {{ title }}
                    </h4>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>                </div>
                <div class="modal-body">
                    {{ content }}
                </div>
                <div class="modal-footer">
                    {{ _self.cancelBtnModal() }}

                    <form method="post" action="{{ path(pathAction, {id: id}) }}" style="display: inline-block">
                        <input type="hidden" name="_token" value="{{ csrf_token('postForm' ~ id) }}">
                        <button type="submit" class="btn btn-danger submit_post">
                            {{ confirmMessage | raw }}
                        </button>
                    </form>
                </div>
            </div>
        </div>
    </div>
{%- endmacro -%}

{% macro button_top_open_modal_post(title, content, pathAction, icon, btn_description = "Envoyer",
    confirmMessage = '<span class="fas fa-exclamation-circle"></span> Confirmer' ) %}

    {% set htmlId = random() %}

    <button type="button" class="btn btn-outline-primary" title="{{ btn_description }}"
            data-bs-target="#post{{ htmlId }}" data-bs-toggle="modal">
        <span class="{{ icon }}"></span>
        {{ btn_description }}
    </button>

    <div id="post{{ htmlId }}" class="modal fade" role="dialog" data-bs-backdrop="static">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header align-items-start">
                    <h4 class="modal-title">
                        {{ title }}
                    </h4>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    {{ content }}
                </div>
                <div class="modal-footer">
                    {{ _self.cancelBtnModal() }}

                    <form method="post" action="{{ path(pathAction) }}"
                          style="display: inline-block">
                        <input type="hidden" name="_token" value="{{ csrf_token('postForm') }}">
                        <button type="submit" class="btn btn-danger submit_post">
                            {{ confirmMessage | raw }}
                        </button>
                    </form>
                </div>
            </div>
        </div>
    </div>
{%- endmacro -%}

{% macro cancelBtnModal(cancelName = 'Annuler') %}
    <button type="button" class="btn btn-link" data-bs-dismiss="modal" title="">
        <span class="fa fa-times"></span>
        Annuler
    </button>
{% endmacro %}

{% macro fetchLsvoteResults(title, id ) %}
    <button type="button" class="btn btn-outline-primary" data-bs-toggle="modal" data-bs-target="#modal-lsvote-result">
        <i class="fa fa-download me-2"></i>Récupérer les résultats depuis lsvote
    </button>

    <div class="modal fade" id="modal-lsvote-result" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Récupérer les résultats de la séance {{ title }}</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <div class="alert alert-warning">
                        <div class="fw-bold">
                            <i class="fa fa-exclamation-triangle"></i>
                            Cette action est irréversible.
                        </div>
                        <p>Assurez-vous que toutes vos modifications soient à jour côté lsvote avant de lancer la récupération des résultats.</p>
                    </div>
                    <p class="mt-3">Êtes-vous sûr de vouloir lancer la récupération des résultats ?</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-link" data-bs-dismiss="modal" title="annuler">
                        <span class="fa fa-times"></span>
                        Annuler
                    </button>
                    <a href="{{ path('sitting_lsvote_results', {'id': id }) }}" type="button" class="btn btn-primary" title="Télécharger les résultats">
                        <i class="fa fa-download"></i>
                        Récupérer les résultats
                    </a>
                </div>
            </div>
        </div>
    </div>
{% endmacro %}

{% macro btnInvalidePasswordsWithModal(title, content, pathAction, btn_description = "Invalidation des mots de passe") %}
    {% set htmlId = random() %}

    <button type="button" class="btn btn-outline-primary" title="{{ btn_description }}"
            data-bs-target="#post{{ htmlId }}" data-bs-toggle="modal">
        <span class="fa-passwd-reset fa-stack small">
            <i class="fa fa-sync-alt fa-stack-2x"></i>
            <i class="fa fa-lock fa-stack-1x small font-weight-bold"></i>
        </span>
        {{ btn_description }}
    </button>

    <div id="post{{ htmlId }}" class="modal fade" role="dialog" data-bs-backdrop="static">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header align-items-start">
                    <h4 class="modal-title">
                        {{ title }}
                    </h4>
                    <button type="button" class="btn-close"  id="close-invalidate" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    {{ content }}

                    <div class="mt-3  alert alert-soft-warning">
                        <label for="invalidatePassword" class="form-label">
                            <i class="fa fa-exclamation-triangle"></i>
                            Merci de taper le mot <b>INVALIDER</b> afin de confirmer l'invalidation des mots de passe
                        </label>
                        <div class="input-group mb-3">
                            <input type="text" class="form-control" id="invalidate-password" aria-describedby="basic-addon3" data-invalidate="INVALIDER">
                        </div>
                    </div>


                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-link" data-bs-dismiss="modal" id="invalidate-cancel-btn">
                        <span class="fa fa-times"></span>
                        Annuler
                    </button>

                    <form method="post" action="{{ path(pathAction) }}" style="display: inline-block">
                        <input type="hidden" name="_token" value="{{ csrf_token('postForm') }}">
                        <button type="submit" class="btn btn-danger submit_post" id="invalidate-confirm-btn" disabled>
                            <span class="fas fa-exclamation-triangle"></span>
                            Invalider tous les mots de passe
                        </button>
                    </form>
                </div>
            </div>
        </div>
    </div>
{% endmacro %}

{% macro btnInvalidateSinglePasswordWithModal(id, title, pathAction, content, page = 1) %}
    <button type="button" class="btn btn-outline-primary borderless stacked" title="Invalidation du mot de passe de l'utilisateur"
            data-bs-target="#modalReload{{ id }}" data-bs-toggle="modal" >
        <span class="fa-passwd-reset fa-stack small">
            <i class="fa fa-sync-alt fa-stack-2x"></i>
            <i class="fa fa-lock fa-stack-1x small font-weight-bold"></i>
        </span>
    </button>

    <div id="modalReload{{ id }}" tabindex="-1" class="modal fade" aria-hidden="true" data-bs-backdrop="static" data-bs-keyboard="false">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header align-items-start">
                    <h4 class="modal-title">{{ title }}</h4>
                    <button type="button" class="btn-close close-invalidate-single" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    {{ content }}
                    <div class="mt-3  alert alert-soft-warning">
                        <label for="invalidateSinglePassword" class="form-label">
                            <i class="fa fa-exclamation-triangle"></i>
                            Merci de taper le mot <b>INVALIDER</b> afin de confirmer l'invalidation du mot de passe
                        </label>
                        <div class="input-group mb-3">
                            <input type="text" class="form-control invalidate-input" aria-describedby="basic-addon3" data-invalidate="INVALIDER">
                        </div>
                    </div>


                </div>

                <div class="modal-footer">
                    <button type="button" class="btn btn-link invalidate-single-cancel-btn" data-bs-dismiss="modal" title="Annuler">
                        <span class="fa fa-times"></span>
                        Annuler
                    </button>
                    <form method="post" action="{{ path(pathAction, {id: id, page: page}) }}" style="display: inline-block">
                        <input type="hidden" name="_method" value="POST">
                        <button type="submit" class="btn btn-primary invalidate-single-confirm-btn" disabled>
                            <span class="fas fa-sync-alt"></span>
                            Invalider le mot de passe
                        </button>
                    </form>
                </div>
            </div>
        </div>
    </div>
{% endmacro %}

{% macro button_open_modal_secure_delete(id, title, pathAction, content, page = 1, titleAttribut = 'Supprimer') %}
    <button type="button" class="btn btn-outline-danger borderless" title="{{ titleAttribut }}"
            data-bs-target="#delete{{ id }}" data-bs-toggle="modal">
        <span class="fa fa-trash-alt"></span>
    </button>

    <div id="delete{{ id }}" class="modal fade" role="dialog" data-bs-backdrop="static">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header d-flex align-items-start">
                    <h4 class="modal-title">
                        {{ title }}
                    </h4>
                    <button type="button" class="btn-close delete-close-btn" data-bs-dismiss="modal" aria-label="Close" ></button>
                </div>
                <div class="modal-body">
                    {{ content | nl2br | raw }}
                    <div class="mt-3  alert alert-soft-warning">
                        <label for="invalidateSinglePassword" class="form-label">
                            <i class="fa fa-exclamation-triangle"></i>
                            Merci de taper le mot <b>SUPPRIMER</b> afin de confirmer la suppression.
                        </label>
                        <div class="input-group mb-3">
                            <input type="text" class="form-control delete-input" data-delete="SUPPRIMER">
                        </div>
                    </div>

                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-link cancel-delete-btn" data-bs-dismiss="modal" title="">
                        <span class="fa fa-times"></span>
                        Annuler
                    </button>

                    <form method="post" action="{{ path(pathAction, {id: id, page: page}) }}" style="display: inline-block">
                        <input type="hidden" name="_method" value="DELETE">
                        <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ id) }}">
                        <button type="submit" class="btn btn-danger delete-btn" disabled>
                            <span class="fa fa-trash-alt"></span>
                            Supprimer
                        </button>
                    </form>
                </div>
            </div>
        </div>
    </div>
{% endmacro %}

